Syncing Charts in JavaScript

Using ApexCharts with JavaScript

This Syncing Charts example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// The global window.Apex variable below can be used to set common options for all charts on the page
Apex = {
  chart: {
    height: 130,
  },
  title: {
    style: {
      fontSize: '14px',
    },
  },
  dataLabels: {
    enabled: false,
  },
  stroke: {
    curve: 'straight',
  },
  toolbar: {
    tools: {
      selection: false,
    },
  },
  markers: {
    size: 6,
    hover: {
      size: 10,
    },
  },
  tooltip: {
    followCursor: false,
    theme: 'dark',
    x: {
      show: false,
    },
    marker: {
      show: false,
    },
    y: {
      title: {
        formatter: function () {
          return ''
        },
      },
    },
  },
  grid: {
    clipMarkers: false,
  },
  yaxis: {
    tickAmount: 2,
  },
  xaxis: {
    type: 'datetime',
  },
}

// Deterministic daily random walks so every chart shares the same date range
// and the synced crosshair always has data under it.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function dailySeries(seed, count, base, spread) {
  var rand = mulberry32(seed)
  var series = []
  var ts = new Date('01 Jun 2025').getTime()
  var val = base
  for (var i = 0; i < count; i++) {
    val += (rand() - 0.5) * spread
    series.push([ts, Math.round(val)])
    ts += 86400000
  }
  return series
}

var options = {
  series: [
    {
      name: 'Page Views',
      data: dailySeries(11, 20, 42, 18),
    },
  ],
  chart: {
    id: 'pageviews',
    group: 'website',
    type: 'line',
    height: 130,
  },
  title: {
    text: 'Page Views (k)',
  },
  colors: ['#008FFB'],
}

var chart = new ApexCharts(document.querySelector('#chart-line'), options)
chart.render()

var optionsLine2 = {
  series: [
    {
      name: 'Sessions',
      data: dailySeries(23, 20, 20, 8),
    },
  ],
  chart: {
    id: 'sessions',
    group: 'website',
    type: 'line',
    height: 130,
  },
  title: {
    text: 'Sessions (k)',
  },
  colors: ['#546E7A'],
}

var chartLine2 = new ApexCharts(
  document.querySelector('#chart-line2'),
  optionsLine2,
)
chartLine2.render()

var optionsArea = {
  series: [
    {
      name: 'Sign-ups',
      data: dailySeries(35, 20, 38, 16),
    },
  ],
  chart: {
    id: 'signups',
    group: 'website',
    type: 'area',
    height: 130,
  },
  title: {
    text: 'Sign-ups',
  },
  colors: ['#00E396'],
}

var chartArea = new ApexCharts(
  document.querySelector('#chart-area'),
  optionsArea,
)
chartArea.render()

Syncing Charts in React

Using ApexCharts with React

This Syncing Charts example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// The global window.Apex variable below can be used to set common options for all charts on the page
Apex = {
  chart: {
    height: 130,
  },
  title: {
    style: {
      fontSize: '14px',
    },
  },
  dataLabels: {
    enabled: false,
  },
  stroke: {
    curve: 'straight',
  },
  toolbar: {
    tools: {
      selection: false,
    },
  },
  markers: {
    size: 6,
    hover: {
      size: 10,
    },
  },
  tooltip: {
    followCursor: false,
    theme: 'dark',
    x: {
      show: false,
    },
    marker: {
      show: false,
    },
    y: {
      title: {
        formatter: function () {
          return ''
        },
      },
    },
  },
  grid: {
    clipMarkers: false,
  },
  yaxis: {
    tickAmount: 2,
  },
  xaxis: {
    type: 'datetime',
  },
}

// Deterministic daily random walks so every chart shares the same date range
// and the synced crosshair always has data under it.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function dailySeries(seed, count, base, spread) {
  var rand = mulberry32(seed)
  var series = []
  var ts = new Date('01 Jun 2025').getTime()
  var val = base
  for (var i = 0; i < count; i++) {
    val += (rand() - 0.5) * spread
    series.push([ts, Math.round(val)])
    ts += 86400000
  }
  return series
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Page Views',
        data: dailySeries(11, 20, 42, 18),
      },
    ],
    options: {
      chart: {
        id: 'pageviews',
        group: 'website',
        type: 'line',
        height: 130,
      },
      title: {
        text: 'Page Views (k)',
      },
      colors: ['#008FFB'],
    },
    seriesLine2: [
      {
        name: 'Sessions',
        data: dailySeries(23, 20, 20, 8),
      },
    ],
    optionsLine2: {
      chart: {
        id: 'sessions',
        group: 'website',
        type: 'line',
        height: 130,
      },
      title: {
        text: 'Sessions (k)',
      },
      colors: ['#546E7A'],
    },
    seriesArea: [
      {
        name: 'Sign-ups',
        data: dailySeries(35, 20, 38, 16),
      },
    ],
    optionsArea: {
      chart: {
        id: 'signups',
        group: 'website',
        type: 'area',
        height: 130,
      },
      title: {
        text: 'Sign-ups',
      },
      colors: ['#00E396'],
    },
  })

  return (
    <div>
      <div id="wrapper">
        <div id="chart-line">
          <ReactApexChart
            options={state.options}
            series={state.series}
            type="line"
            height={130}
          />
        </div>
        <div id="chart-line2">
          <ReactApexChart
            options={state.optionsLine2}
            series={state.seriesLine2}
            type="line"
            height={130}
          />
        </div>
        <div id="chart-area">
          <ReactApexChart
            options={state.optionsArea}
            series={state.seriesArea}
            type="area"
            height={130}
          />
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Syncing Charts in Angular

Using ApexCharts with Angular

This Syncing Charts example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide
import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
          return function () {
            seed |= 0
            seed = (seed + 0x6d2b79f5) | 0
            var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
            t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
            return ((t ^ (t >>> 14)) >>> 0) / 4294967296
          }
        };

  private dailySeries = (seed: any, count: any, base: any, spread: any): any => {
          var rand = this.mulberry32(seed)
          var series = []
          var ts = new Date('01 Jun 2025').getTime()
          var val = base
          for (var i = 0; i < count; i++) {
            val += (rand() - 0.5) * spread
            series.push([ts, Math.round(val)])
            ts += 86400000
          }
          return series
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Page Views',
              data: this.dailySeries(11, 20, 42, 18),
            },
          ],
          chart: {
            id: 'pageviews',
            group: 'website',
            type: 'line',
            height: 130,
          },
          title: {
            text: 'Page Views (k)',
          },
          colors: ['#008FFB'],
        };

  public chartOptions2: Partial<ChartOptions> = {
          series: [
            {
              name: 'Sessions',
              data: this.dailySeries(23, 20, 20, 8),
            },
          ],
          chart: {
            id: 'sessions',
            group: 'website',
            type: 'line',
            height: 130,
          },
          title: {
            text: 'Sessions (k)',
          },
          colors: ['#546E7A'],
        };

  public chartOptions3: Partial<ChartOptions> = {
          series: [
            {
              name: 'Sign-ups',
              data: this.dailySeries(35, 20, 38, 16),
            },
          ],
          chart: {
            id: 'signups',
            group: 'website',
            type: 'area',
            height: 130,
          },
          title: {
            text: 'Sign-ups',
          },
          colors: ['#00E396'],
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    (window as any).Apex = {
            chart: {
              height: 130,
            },
            title: {
              style: {
                fontSize: '14px',
              },
            },
            dataLabels: {
              enabled: false,
            },
            stroke: {
              curve: 'straight',
            },
            toolbar: {
              tools: {
                selection: false,
              },
            },
            markers: {
              size: 6,
              hover: {
                size: 10,
              },
            },
            tooltip: {
              followCursor: false,
              theme: 'dark',
              x: {
                show: false,
              },
              marker: {
                show: false,
              },
              y: {
                title: {
                  formatter: () => {
                    return ''
                  },
                },
              },
            },
            grid: {
              clipMarkers: false,
            },
            yaxis: {
              tickAmount: 2,
            },
            xaxis: {
              type: 'datetime',
            },
          }
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Syncing Charts in Vue

Using ApexCharts with Vue

This Syncing Charts example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="wrapper">
      <div id="chart-line">
        <apexchart
          type="line"
          height="130"
          :options="chartOptions"
          :series="series"
        ></apexchart>
      </div>
      <div id="chart-line2">
        <apexchart
          type="line"
          height="130"
          :options="chartOptionsLine2"
          :series="seriesLine2"
        ></apexchart>
      </div>
      <div id="chart-area">
        <apexchart
          type="area"
          height="130"
          :options="chartOptionsArea"
          :series="seriesArea"
        ></apexchart>
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// The global window.Apex variable below can be used to set common options for all charts on the page
Apex = {
  chart: {
    height: 130,
  },
  title: {
    style: {
      fontSize: '14px',
    },
  },
  dataLabels: {
    enabled: false,
  },
  stroke: {
    curve: 'straight',
  },
  toolbar: {
    tools: {
      selection: false,
    },
  },
  markers: {
    size: 6,
    hover: {
      size: 10,
    },
  },
  tooltip: {
    followCursor: false,
    theme: 'dark',
    x: {
      show: false,
    },
    marker: {
      show: false,
    },
    y: {
      title: {
        formatter: function () {
          return ''
        },
      },
    },
  },
  grid: {
    clipMarkers: false,
  },
  yaxis: {
    tickAmount: 2,
  },
  xaxis: {
    type: 'datetime',
  },
}

// Deterministic daily random walks so every chart shares the same date range
// and the synced crosshair always has data under it.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function dailySeries(seed, count, base, spread) {
  var rand = mulberry32(seed)
  var series = []
  var ts = new Date('01 Jun 2025').getTime()
  var val = base
  for (var i = 0; i < count; i++) {
    val += (rand() - 0.5) * spread
    series.push([ts, Math.round(val)])
    ts += 86400000
  }
  return series
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Page Views',
          data: dailySeries(11, 20, 42, 18),
        },
      ],
      chartOptions: {
        chart: {
          id: 'pageviews',
          group: 'website',
          type: 'line',
          height: 130,
        },
        title: {
          text: 'Page Views (k)',
        },
        colors: ['#008FFB'],
      },
      seriesLine2: [
        {
          name: 'Sessions',
          data: dailySeries(23, 20, 20, 8),
        },
      ],
      chartOptionsLine2: {
        chart: {
          id: 'sessions',
          group: 'website',
          type: 'line',
          height: 130,
        },
        title: {
          text: 'Sessions (k)',
        },
        colors: ['#546E7A'],
      },
      seriesArea: [
        {
          name: 'Sign-ups',
          data: dailySeries(35, 20, 38, 16),
        },
      ],
      chartOptionsArea: {
        chart: {
          id: 'signups',
          group: 'website',
          type: 'area',
          height: 130,
        },
        title: {
          text: 'Sign-ups',
        },
        colors: ['#00E396'],
      },
    }
  },
}
</script>

<style>
#wrapper {
  padding-top: 20px;
  padding-left: 10px;
  background: #fff;
  border: 1px solid #ddd;
  box-shadow: 0 22px 35px -16px rgba(0, 0, 0, 0.1);
  max-width: 650px;
  margin: 35px auto;
}
</style>